package com.bcxin.tenant.domain.entities;

import com.bcxin.Infrastructures.entities.EntityAbstract;
import com.bcxin.Infrastructures.entities.IAggregate;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * description：发送短信表
 * author：linchunpeng
 * date：2024/4/17
 */
@EqualsAndHashCode(callSuper = true)
@Table(name = "shared_messages")
@Entity
@Data
public class SharedMessagesEntity extends EntityAbstract implements IAggregate {

    /**
     * 主键
     */
    @Id
    @Column(name = "id")
    private String id;

    @Column(name = "business_number")
    private String businessNumber;

    @Column(name = "content")
    private String content;

    @Column(name = "created_time")
    private Date createdTime;

    @Column(name = "last_processed_time")
    private Date lastProcessedTime;

    @Column(name = "message_type")
    private Integer messageType;

    @Column(name = "parameter_json")
    private String parameterJson;

    @Column(name = "receiver")
    private String receiver;

    @Column(name = "receiver_type")
    private Integer receiverType;

    @Column(name = "sender_id")
    private String senderId;

    @Column(name = "status")
    private Integer status;

    @Column(name = "unique_id")
    private String uniqueId;

    @Column(name = "title")
    private String title;

}
