package com.bcxin.tenant.domain.services.commands;

import com.bcxin.Infrastructures.commands.CommandAbstract;
import com.bcxin.Infrastructures.enums.CredentialType;
import com.bcxin.Infrastructures.enums.InvitedStatus;
import com.bcxin.Infrastructures.enums.InvitedType;
import com.bcxin.Infrastructures.enums.OccupationType;
import lombok.Getter;

import java.util.Date;

@Getter
public class InvitedToJoinQueuesCommand extends CommandAbstract {
    private final String name;
    private final String telephone;
    private final CredentialType credentialType;
    private final String credentialNumber;
    private final InvitedType invitedType;
    private final String departmentId;
    private final String inviteId;
    private final OccupationType occupationType;

    //身份证人像面
    private final String frontPhoto;
    //身份证国徽面
    private final String reversePhoto;
    //身份证人头像
    private final String headPhoto;
    //有效期从
    private final Date validDateFrom;
    //有效期到
    private final Date validDateTo;
    //地址
    private final String address;
    //活体采集照片
    private final String certificateImage;

    public InvitedToJoinQueuesCommand(String name,
                                      String telephone,
                                      CredentialType credentialType,
                                      String credentialNumber,
                                      InvitedType invitedType,
                                      String departmentId,
                                      String inviteId,
                                      OccupationType occupationType,
                                      String frontPhoto,
                                      String reversePhoto,
                                      String headPhoto,
                                      Date validDateFrom,
                                      Date validDateTo,
                                      String address,
                                      String certificateImage) {
        this.name = name;
        this.telephone = telephone;
        this.credentialType = credentialType;
        this.credentialNumber = credentialNumber;
        this.invitedType = invitedType;
        this.departmentId = departmentId;
        this.inviteId = inviteId;
        this.occupationType = occupationType;
        this.frontPhoto = frontPhoto;
        this.reversePhoto = reversePhoto;
        this.headPhoto = headPhoto;
        this.validDateFrom = validDateFrom;
        this.validDateTo = validDateTo;
        this.address = address;
        this.certificateImage = certificateImage;
    }

    public static InvitedToJoinQueuesCommand create(String name,
                                                    String telephone,
                                                    CredentialType credentialType,
                                                    String credentialNumber,
                                                    InvitedType invitedType,
                                                    String departmentId,
                                                    String inviteId,
                                                    OccupationType occupationType,
                                                    String frontPhoto,
                                                    String reversePhoto,
                                                    String headPhoto,
                                                    Date validDateFrom,
                                                    Date validDateTo,
                                                    String address,
                                                    String certificateImage) {
        return new InvitedToJoinQueuesCommand(name,telephone,credentialType,credentialNumber,
                invitedType,departmentId,inviteId,occupationType,frontPhoto, reversePhoto, headPhoto,
                validDateFrom, validDateTo, address, certificateImage);
    }
}
